<?php
namespace CADSUP\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;

class ger07100Controller {

     public function __construct($service) {
        $this->service = $service;
    }

	public function insertFornecedor(DTO\Request $request, DTO\Response $response) {
		try {
            $row = $request->getRow();
            
            $fornecedor = $this->service->getFornecedor($row);
            
            if ($fornecedor){
            	throw new \Exception("CODE_EXIST");	
            } 
            
            $nomeTipoFornecedor = $this->service->verificaNome($row);
            
            if ($nomeTipoFornecedor){
            	throw new \Exception("NAME_EXIST");	
            }
            
			$this->service->insertFornecedor($row);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function updateFornecedor(DTO\Request $request, DTO\Response $response) 
	{
		try {
			$row = $request->getRow();
			
			if($row['OLD_NMTIPOFORN'] != $row['NMTIPOFORN']){
				$nomeTipoFornecedor = $this->service->verificaNome($row);
		        
		        if($nomeTipoFornecedor){
		        	throw new \Exception("NAME_EXIST");	
		        }
		    }
			$this->service->updateFornecedor($row);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function deleteFornecedor(DTO\Request $request, DTO\Response $response) 
	{
		try {
			$row = $request->getRow();
            
            if($this->service->checkConstraint($row)){
            	throw new \Exception("EXIST_FORN_RELAC");	
		    }
            
			$this->service->deleteFornecedor($row);
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
}