/* Tabela BOLETPAGAR: Boleto a Pagar */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela BOLETPAGAR */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Boleto a Pagar,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_BOLETPAG
AFTER DELETE OR INSERT OR UPDATE
ON BOLETPAGAR FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      V_TIPO   := '3';
      V_DESC   := 'Venc '       || TO_CHAR(:OLD.DTVENBOLPAG, 'DD/MM/YYYY')  ||
                  ' VrLiq '     || TO_CHAR(:OLD.VRFINALBPAG)                ||
                  ' Status '    || :OLD.IDSTATBPAG                          ||
                  ' ContCC '    || :OLD.CDREDUCONT                          ||
                  ' TpBx '      || :OLD.CDTPBAIXAPAG                        ||
                  ' Empr '      || :OLD.CDEMPRESA                           ||
                  ' Parc '      || :OLD.NRPARCBOLPAG                        ||
                  ' VrOrig '    || TO_CHAR(:OLD.VRBOLPAG)                   ||
                  ' SitCNAB '   || :OLD.IDSITUCNABP                         ||
                  ' FiliBx '    || :OLD.CDFILIBAIPAG                        ||
                  ' NrBaixa '   || :OLD.NRBAIXAPAG                          ||
                  ' ParcOrig '  || :OLD.NRORIGBOLPAG                        ||
                  ' NosNum '    || :OLD.CDNOSNUMPAG                         ||
                  ' BancCred '  || :OLD.CDBANCBOLP                          ||
                  ' AgenCred '  || :OLD.CDAGENBOLP                          ||
                  ' ContaCred ' || :OLD.CDCCORBOLP;

      V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANBOLPAG|| '/' ||
                        :OLD.CDFILIBAIPAG||:OLD.NRBAIXAPAG|| '/' ||
                        :OLD.NRCNABPAGREM;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANBOLPAG|| '/' ||
                           :NEW.CDFILIBAIPAG||:NEW.NRBAIXAPAG|| '/' ||
                           :NEW.NRCNABPAGREM;
         V_CDFILLOGOPER := :OLD.CDFILIAL;

         IF (:NEW.DTVENBOLPAG  <> :OLD.DTVENBOLPAG)  OR
            (:NEW.VRFINALBPAG  <> :OLD.VRFINALBPAG)  OR
            (:NEW.IDSTATBPAG   <> :OLD.IDSTATBPAG)   OR
            (:NEW.CDFILIAL     <> :OLD.CDFILIAL)     OR
            (:NEW.NRLANBOLPAG  <> :OLD.NRLANBOLPAG)  OR
            (:NEW.CDREDUCONT   <> :OLD.CDREDUCONT)   OR
            (:NEW.CDTPBAIXAPAG <> :OLD.CDTPBAIXAPAG) OR
            (:NEW.NRPARCBOLPAG <> :OLD.NRPARCBOLPAG) OR
            (:NEW.IDSITUCNABP  <> :OLD.IDSITUCNABP)  OR
            (:NEW.NRBAIXAPAG   <> :OLD.NRBAIXAPAG)   OR
            (:NEW.CDNOSNUMPAG  <> :OLD.CDNOSNUMPAG)  OR
            (:NEW.CDBANCBOLP   <> :OLD.CDBANCBOLP)   OR
            (:NEW.CDAGENBOLP   <> :OLD.CDAGENBOLP)   OR
            (:NEW.CDCCORBOLP   <> :OLD.CDCCORBOLP)   THEN
            V_TIPO   := '2';
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.NRLANBOLPAG|| '/' ||
                           :NEW.CDFILIBAIPAG||:NEW.NRBAIXAPAG|| '/' ||
                           :NEW.NRCNABPAGREM;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      V_DESC   := 'Venc '       || TO_CHAR(:NEW.DTVENBOLPAG, 'DD/MM/YYYY')  ||
                  ' VrLiq '     || TO_CHAR(:NEW.VRFINALBPAG)                ||
                  ' Status '    || :NEW.IDSTATBPAG                          ||
                  ' ContCC '    || :NEW.CDREDUCONT                          ||
                  ' TpBx '      || :NEW.CDTPBAIXAPAG                        ||
                  ' Empr '      || :NEW.CDEMPRESA                           ||
                  ' Parc '      || :NEW.NRPARCBOLPAG                        ||
                  ' VrOrig '    || TO_CHAR(:NEW.VRBOLPAG)                   ||
                  ' SitCNAB '   || :NEW.IDSITUCNABP                         ||
                  ' FiliBx '    || :NEW.CDFILIBAIPAG                        ||
                  ' NrBaixa '   || :NEW.NRBAIXAPAG                          ||
                  ' ParcOrig '  || :NEW.NRORIGBOLPAG                        ||
                  ' NosNum '    || :NEW.CDNOSNUMPAG                         ||
                  ' BancCred '  || :NEW.CDBANCBOLP                          ||
                  ' AgenCred '  || :NEW.CDAGENBOLP                          ||
                  ' ContaCred ' || :NEW.CDCCORBOLP;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('BOLETPAGAR', V_DTOPER, V_USUARIO,
                V_TIPO,       V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_BOLETPAG','5.20.000'); END;
/

